/*
 * hal_shell.hpp
 *
 *  Created on: 19 мар. 2019 г.
 *      Author: Lityagin Aleksandr
 *      Author: alexrayne <alexraynepe196@gmail.com>
  ------------------------------------------------------------------------
    Copyright (c) alexrayne

   All rights reserved.
   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
   - Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
   - Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
   - Neither the name of ARM nor the names of its contributors may be used
     to endorse or promote products derived from this software without
     specific prior written permission.
   *
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL COPYRIGHT HOLDERS AND CONTRIBUTORS BE
   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGE. *
 */

#ifndef HAL_LIB_HAL_SHELL_HPP_
#define HAL_LIB_HAL_SHELL_HPP_

#include "cli.hpp"

typedef StdOUT_PrintBuffer<512> CLIShellPrinter;

class Device_CLI_shell
    : public CLI_shell
    , public StdOUT_ProxyPrint
    //,  public Device_Observer
{
public:
    typedef CLI_shell inherited;
    Device_CLI_shell();
    Device_CLI_shell(StdIO_Device *device);
//    virtual void handleEvent(StdIO_Device_Observable *observable){this->addChar(observable->get_char());}
//    virtual void handleEvent(Observer_Meta *observable){this->handleEvent(((StdIO_Device_Observable * )observable));}
protected:
    CLIShellPrinter     printer;
    StdIO_Device*       device;
public:
    static const unsigned get_poll_toms = 100;

    void init(StdIO_Device *device);
    StdIO_Device* io(){return device;};
    StdPrint&     out(){return printer;};
    void execute(const char* prompt = ">");

    void addChar(u8 ch);
    virtual int getLine(char* line, unsigned limit, char eol = '\n');
    //* readline from io
    int readLine(char* line, unsigned limit, char eol = '\n');
    virtual int puts(const char* s);

    virtual void on_fail(const char* s);
    virtual bool ask_yes(void);
};


#endif /* HAL_LIB_HAL_SHELL_HPP_ */
